#line 1 "C:/_MikroC/_MesProjets_MikroC/_BlueTooth_BLE/_12F1840_EA2_UART1_UART_Soft_BLE_171019.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 67 "C:/_MikroC/_MesProjets_MikroC/_BlueTooth_BLE/_12F1840_EA2_UART1_UART_Soft_BLE_171019.c"
sbit Relay1 at LATA.B0 ;
sbit Relay1_Direction at TRISA.B0 ;


volatile unsigned char buffer1[ 44  ];
volatile unsigned char * p1;
char TEXTE[46];
char CRam1[22];
char *txt;


unsigned short error=0;
volatile unsigned int CptErr=0;
volatile int Index1=0;
volatile unsigned char c1=0;
volatile unsigned int i1=0;
volatile int Flag_Buffer1;
unsigned int i=0;
unsigned int j=0;
unsigned int k=0;

unsigned int EAx=0;

 unsigned int  Pas=0;
 unsigned int  Flag_Timer0=0;
 unsigned int  Count0=0;


void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF1(void);
void interrupt(void) ;
void RAZ_Buffer1(void);


void UART3_Write_Text(char * t) ;
void UART3_Write_CText(const char * t);
void Wait_250mS(void);
void CRLF3(void) ;
unsigned int Lecture_ADC(unsigned char ch);

void Interrupts() iv 0x0004 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
 {
 c1 = RCREG;


 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 TXREG='@';
 RCSTA.CREN = 1 ;
 CptErr++;

 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 TXREG='*';
 CptErr++;
 c1 = RCREG;
 }

 if ( ( (i1>0) && (c1== 10 )) || ((i1>0) && (c1== 13 )) || (i1>= 44 -1) )

 {
 buffer1[i1]=0;
 if (c1== 13 ) c1=RCREG;
 Flag_Buffer1=1;
 Index1=i1;
 i1++;
 RCIE_bit=0 ;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;

 }
 }
 if((TMR0IE_bit)&&(TMR0IF_bit))
 {
 Count0--;
 if (Count0>0)
 {
 TMR0=6;
 }
 else
 {
 Count0=0;
 Flag_Timer0=1;
 TMR0IE_bit=0;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 TMR0IF_bit=0;
 }

 }


void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt) {
 while (*txt)
 UART1_Write(*txt++);
 Delay_ms(1);

}


void Init_Timer0(unsigned int V1)
{

 OPTION_REG = 0x87;
 TMR0 = 6;
 INTCON = 0xA0;
 TMR0IE_bit=1;
 Count0=V1;
 TMR0IF_bit=0;
 Flag_Timer0=0;

}

void Raz_Buffer1()
{
 Flag_Buffer1 =0;

 for(Index1=0;Index1< 44 -1;Index1++) buffer1[Index1]=0;
 c1=RCREG;
 p1=0;
 i1=0;
 Index1=0;
 c1=0;
 RCIE_bit = 1;

}

void Stop_Timer0(void)
{
 Flag_Timer0=0;
 TMR0=6;
 TMR0IF_bit=0;
 TMR0IE_bit=0;
 Count0=0;
 }

void Send_Cde_display_response(const char* Cde)
{ char *p2;
 Raz_Buffer1();
 p2=0;
 UART3_Write_CText(Cde);
 strConstRamCpy(txt,Cde);
 k=strlen(txt);
 *(txt-1)=0;
 UART1_Write_Text(txt);
 Init_Timer0(100) ;
 while((p2==0) && (Flag_Timer0==0) )
 {
 Delay_ms(100);
 p2=strstr(buffer1,"OK");
 }
 Stop_Timer0();
 if(p2>0) Pas++;
 Delay_ms(26);
 }

void BLE_HM10_Init()
{
 int N;

 N=0;
 while(N<11)
 {
 UART1_Write_CText("BlaBla_Car");
 N++;
 }
 CRLF1();
 strConstRamCpy(CRam1,"OK");
 Send_Cde_display_response("AT\r\n");
 Send_Cde_display_response("AT+RESET\r\n");


 Send_Cde_display_response("AT+VERSION\r\n");
 Send_Cde_display_response("AT+PIN123456\r\n");
 Send_Cde_display_response("AT+NAMEHM10_7EE1\r\n");
 Send_Cde_display_response("AT+ADDR\r\n");
 Send_Cde_display_response("AT+UUID\r\n");
 Send_Cde_display_response("AT+POWE\r\n");
}



void UART3_Write_Text(char * t)
{
while(*(t)>0)
{
Soft_UART_Write(*(t++));
}
}


void UART3_Write_CText(const char * t)
{
 while(*(t)>0)
 {
 Soft_UART_Write(*(t++));
 }
}

 void Wait_250mS()
 {
 Delay_ms(250);
 }


void CRLF3(void)
{
Soft_UART_Write(13); Soft_UART_Write(10);
}

 unsigned int Lecture_ADC(unsigned char ch)
 {
 unsigned int k;




 ADCON0=(ch<<2) +1;
 Delay_ms(15);
 ADCON0.GO=1;
 _asm nop
 while( ADCON0.GO==1);
 k=ADRESH<<8;
 k=k + ADRESL;
 return (k);
 }



void main()
{





 OSCCON=0b01111000;
 Wait_250mS();

 OPTION_REG=0;
 ANSELA=0b00000010;


 TRISA =0b00101010;





 CCP1CON=0;
 CCP1AS=0b00001000;
 CM1CON0=0x07;
 CM1CON1=0x07;
 FVREN_bit=0;
 SRCON0=0;
 SRCON1=0;
 SRLEN_bit=0;

 _asm NOP ;

 APFCON=0;
 APFCON.P1BSEL=1;
 _asm NOP ;
 APFCON.RXDTSEL=1;
 _asm NOP ;
 APFCON.TXCKSEL=1;
 _asm NOP ;



 Wait_250mS();






 FVRCON=0;
 FVRCON.B7=1;
 ADFVR1_bit= 0;
 ADFVR0_bit= 1;
 while(FVRRDY_bit==0);

 ADCON0=0;




 ADCON0.CHS0=1;

 ADCON1.ADFM=1;
 ADCON1.ADCS2= 1;
 ADCON1.ADCS1= 1;
 ADCON1.ADCS0= 0;
 ADCON1.ADPREF1=1;
 ADCON1.ADPREF0=1;


 Pas=0;


 Soft_UART_Init(&PORTA,5,2,19200,0);
 UART3_Write_CText("Source:" "_12F1840_EA2_UART1_UART_Soft_BLE" "_" "171019" ".c\r\n");
 UART3_Write_CText("\r\n Init SOFTW.UART3 TX(RA2) RX(RA5)\r\n");



 UART1_Init(19200);
 CRLF1();
 UART1_Write_CText(" Init Hardw.UART1 RX(RA4) TX(RA5)\r\n");
 if (PIR1.RCIF==1) c1 = RCREG;
 if (PIR1.RCIF==1) c1 = RCREG;


 Relay1_Direction=0;
 Relay1= 1 ;
#line 427 "C:/_MikroC/_MesProjets_MikroC/_BlueTooth_BLE/_12F1840_EA2_UART1_UART_Soft_BLE_171019.c"
 txt=&TEXTE[0];
 Raz_Buffer1();
 GIE_bit=0;
 RCIE_bit=0;

 UART3_Write_CText(" Init module BLE HM10 :\r\n");
 Raz_Buffer1();
 BLE_HM10_Init() ;
 UART3_Write_CText("Init OK,r\n");


 UART1_Write_CText("AT+START\r\n");
 UART3_Write_CText("AT+START\r\n");
 Wait_250mS() ;

 PEIE_bit=1;
 RCIE_bit =1;
 GIE_bit=1;
 TMR0IE_bit=0;
 UART3_Write_CText("40 sec pour se Connecter / Android Apli.\r\n");
 Raz_Buffer1();
 i=39;


 while(i>0)
 { Raz_Buffer1();
 Delay_1sec() ;
 if (strstr(buffer1,"+CONN")>0) break;
 j=i/4;
 if(i%4==0)
 {
  Soft_UART_Write (j+48);CRLF3();
 }
 i--;
 if(strstr(buffer1,"ERROR=103")) break;
 };
 if (i>0)
 UART3_Write_CText("\r\nConnection BLE OK.\r\n");
 else
 {
 UART3_Write_CText("\r\nPB module BLE NON Connect\r\n");
 Pas=0;
 Delay_1sec() ;
 UART3_Write_CText("\r\nReset\r\n");
 _asm Goto 0;
 }
 Delay_1sec() ;
 j=0;
 p1=0;
 do
 {
 Raz_Buffer1();
 Delay_1sec() ;

 if(i1>0)
 {

 p1=strstr(buffer1,"LOST");
 if (p1>0)
 {
 UART3_Write_CText("\r\nPerte de Connection BLE \r\n Reset dans 2sec \r\n");
 Delay_1sec() ;
 _asm goto 0;
 }
 p1=strstr(buffer1,"LD1=");
 if (p1>0)
 {
 if (*(p1+4)=='1')
 {
 UART1_Write_CText("S1=1\r\n");
 Relay1= 0 ;
 UART3_Write_CText(" Relay1_ON\r\n");
 }
 if (*(p1+4)=='0')
 {
 UART1_Write_CText("S1=0\r\n");
 Relay1= 1 ;
 UART3_Write_CText(" Relay1_OFF\r\n");
 }

 }
#line 529 "C:/_MikroC/_MesProjets_MikroC/_BlueTooth_BLE/_12F1840_EA2_UART1_UART_Soft_BLE_171019.c"
 UART3_Write_Text(buffer1);
 CRLF3();
 }


 j++;
 UART3_Write_CText("I am Alive j=");
 WordToStr(j,CRam1);
 UART3_Write_Text(CRam1);CRLF3();

 strConstRamCpy(txt ,"j= 1023;E1= 1023");
 strncpy(txt+2,CRam1,5);

 EAx=Lecture_ADC(1);
 WordToStr(EAx,CRam1);
 strncpy(txt+12,CRam1,5);
 UART1_Write_Text(txt);
 CRLF1();

 }while(1);

 }
